import simplegui
import random

width = 600
height = 400
ball_radius = 20
pad_width = 8
pad_height = 80
half_pad_width = pad_width/2
half_pad_height = pad_height/2

padle1_pos = [0,0]
padle2_pos = [0,0]
padle1_vel = [0,0]
padle2_vel = [0,0]
ball_pos = [width/2,height/2]
vel_incr = [0.2,1.4]
score1 = 0
score2 = 0

padle1_pos[0] = height/2-half_pad_height
padle1_pos[1] = height/2+half_pad_height
padle2_pos[0] = height/2-half_pad_height
padle2_pos[1] = height/2+half_pad_height

def ball_init():
    global ball_pos,ball_vel
    #balls initial coordinates
    ball_pos = [width/2,height/2]
    # balls initial velocity
    ball_vel = [2,1]
    pass
def init():
    global padle1_pos,padle2_pos,padle1_vel,padle2_vel #floats
    global padle1_vel,padle2_vel #floats
    global score1,score2 #ints
    padle1_vel = [0,0]    
    padle2_vel = [0,0]
    score1 = score2 = 0
  
        
        
def draw(canvas):
    global padle1_pos,padle2_pos,score1,score2,ball_pos,ball_vel
    global padle1_vel,padle2_vel
    global vel_incr
     #>>>>>>>>>>>>
    
    ball_pos[0] +=  ball_vel[0]
    ball_pos[1] +=  ball_vel[1]
    
    
    #logic for reflection wall testing
    if(ball_pos[0] < (ball_radius)):
        ball_vel[0] = -ball_vel[0]
    elif(ball_pos[0] > (width-1-ball_radius)):
         ball_vel[0] = -ball_vel[0]
    elif(ball_pos[1] < (ball_radius)):
        ball_vel[1] = -ball_vel[1]
    elif(ball_pos[1] > height - 1-(ball_radius)):
        ball_vel[1] = -ball_vel[1]
        
    
    
    #checking for gutters
    if(ball_pos[0] < ball_radius+pad_width):
        score1 = score1 + 1
        ball_init()
    elif (ball_pos[0] > width-1-(ball_radius+pad_width)):
        score2 = score2 + 1
        ball_init()
    
    
    #update padles vertical position
    #vertical velocities of padles    
    padle1_pos[0] +=  padle1_vel[1]
    padle1_pos[1] +=  padle1_vel[1]
    padle2_pos[0] +=  padle2_vel[1]
    padle2_pos[1] +=  padle2_vel[1]
    
    #logic for reflection against a padle
    if( (ball_pos[0] > width-3-(ball_radius+pad_width)) and (ball_pos[1] > padle1_pos[0]) and (ball_pos[1] < padle1_pos[1])):
        ball_vel[0] = ball_vel[0] + vel_incr[0]
        ball_vel[1] = ball_vel[1] + vel_incr[1]
        
        ball_vel[0] = -ball_vel[0]
    elif( ball_pos[0] < (ball_radius+pad_width+4) and (ball_pos[1] > padle2_pos[0]) and (ball_pos[1] < padle2_pos[1]) ):  
        ball_vel[0] = ball_vel[0] - vel_incr[0]
        ball_vel[1] = ball_vel[1] + vel_incr[1]
        ball_vel[0] = -ball_vel[0]
        
    #aesthetic lines
    canvas.draw_line([width/2,0],[width/2,height],1,"White") 
    canvas.draw_line([pad_width,0],[pad_width,height],1,"White") 
    canvas.draw_line([width-pad_width,0],[width-pad_width,height],1,"White") 
   
    # draw padles
    
    canvas.draw_line([width-half_pad_width-1,padle1_pos[0]],[width-1-half_pad_width,padle1_pos[1]],8,"White")
    canvas.draw_line([half_pad_width,padle2_pos[0]],[half_pad_width,padle2_pos[1]],8,"White")
    
    
    
    # update balls
    # draw ball and scores
    
    canvas.draw_text(str(score1)+" | "+str(score2),[270,100],38,"Red" )
    canvas.draw_circle(ball_pos,ball_radius,2,"Red","White")
    
  
        
def keydown(key):
    c=5
    global padle1_vel,padle2_vel
    if key == simplegui.KEY_MAP["up"] :
        padle1_vel[1] -= c
    elif key == simplegui.KEY_MAP["down"] :
        padle1_vel[1] += c
    elif key == simplegui.KEY_MAP["w"] :
        padle2_vel[1] -= c
    elif key == simplegui.KEY_MAP["s"] :
        padle2_vel[1] += c    
        
def keyup(key):
    c=5
    global padle1_vel,padle2_vel
    if key == simplegui.KEY_MAP["up"] :
        padle1_vel[1] += c
    elif key == simplegui.KEY_MAP["down"] :
        padle1_vel[1] -= c
    elif key == simplegui.KEY_MAP["w"] :
        padle2_vel[1] += c
    elif key == simplegui.KEY_MAP["s"] :
        padle2_vel[1] -= c    

def new_game():
    ball_init()    
    
    
frame = simplegui.create_frame("PONG...!!!",width,height)

frame.set_draw_handler(draw)
frame.set_keydown_handler(keydown)
frame.set_keyup_handler(keyup)
frame.add_button("Restart",init,100)

frame.set_draw_handler(draw)

init()
ball_init()
frame.start()
