import math
import simplegui
radius = 20
ball_list = []
height = 400
width = 600
ball_color = "Red"
def distance(p,q):
    d = math.sqrt( (p[0]-q[0])**2 + (p[1]-q[1])**2 )
    return d

def draw(canvas):
    for ball in ball_list:
        canvas.draw_circle([ball[0],ball[1]],radius, 2, "white",ball[2])
    
def click(pos):
    changed = True
    for ball in ball_list:
        if(distance([ball[0],ball[1]],pos) < radius):
            ball[2] = "green"
            changed = False
            
    if changed:
        ball_list.append([pos[0],pos[1],"Red"])

frame = simplegui.create_frame("Drawing Circles",600,400)
frame.set_mouseclick_handler(click)
frame.set_draw_handler(draw)
frame.start()