import simplegui
import random

WIDTH = 600
HEIGHT = 400
PARTICLE_RADIUS = 5
COLOR_LIST = ["Red","Green","Blue","White"]
DIRECTION_LIST = [[5,0],[0,5],[-5,0],[0,-5]]

class Particle:
    def __init__(self,position,color):
        self.position = position
        self.color = color
    def move(self,offset):
        self.position[0] += offset[0]
        self.position[1] += offset[1]
    def draw(self,canvas):
        canvas.draw_circle(self.position,PARTICLE_RADIUS,1,self.color,self.color)
    def __str__(self):
        return "position"+str(self.position)+"Direction : "+"Color: "+self.color

def draw(canvas):
    for p in particle_list:
        p.move(random.choice(DIRECTION_LIST))
       
    for p in particle_list:
        p.draw(canvas)
        
frame = simplegui.create_frame("Particle Motion",WIDTH,HEIGHT)
frame.set_draw_handler(draw)

particle_list = []
for i in range(100):
    p = Particle([WIDTH/2,HEIGHT/2],random.choice(COLOR_LIST))
    particle_list.append(p)
    print p
    
frame.start()